/* Kompilujeme kod pro jadro */
#define __KERNEL__

/* Kompilujeme modul */
#define MODULE

/**************************************************************************/

/* Informace o aktualni konfiguraci jadra a ostatnich modulu */
#include <linux/config.h>

/* makra a definice pro kompilaci jadernych modulu (module_init)*/
#include <linux/module.h>

/* makra a definice pro inicializacni funkce (__init) */
#include <linux/init.h>

/* ostatni makra a casto pouzivane funkce v jadre (printk) */
#include <linux/kernel.h>

/**************************************************************************/

static int cislo = 42;		/* nejaka vnitrni promenna modulu */

/* inicializacni funkce modulu */
int __init MUJ_MODUL_init(void)
{
  printk(KERN_ALERT "MUJ_MODUL: Jsem v jadre!\n");
  printk(KERN_ALERT "MUJ_MODUL: Parametr cislo=%d.\n", cislo);
  return 0;
}

/* ukoncovaci funkce modulu */
void MUJ_MODUL_exit(void)
{
  printk(KERN_ALERT "MUJ_MODUL: Koncim!\n");
}

module_init(MUJ_MODUL_init); /* tato funkce bude zavolana tesne po vlozeni modulu */
module_exit(MUJ_MODUL_exit); /* tato funkce bude zavolana tesne pred uvolnenim modulu */

/* A ted nepovinna makra, ktera definuji vlastnosti modulu */
MODULE_AUTHOR("Studentik Vepeesak");
MODULE_DESCRIPTION("Ukazkovy modul do jadra");
MODULE_PARM(cislo, "i"); /* modul ma integer parametr spojen s promennou cislo */
MODULE_PARM_DESC(cislo, "Libovolne integer cislo, ktere znamena to a to.");
MODULE_LICENSE("GPL");
