/* Kompilujeme kod pro jadro */
#define __KERNEL__

/* Kompilujeme modul */
#define MODULE

/**************************************************************************/

/* Informace o aktualni konfiguraci jadra a ostatnich modulu */
#include <linux/config.h>

/* makra a definice pro kompilaci jadernych modulu (module_init)*/
#include <linux/module.h>

/* makra a definice pro inicializacni funkce (__init) */
#include <linux/init.h>

/* ostatni makra a casto pouzivane funkce v jadre (printk) */
#include <linux/kernel.h>

/* hlavicky pro funkce pracujici s PROC filesystemem */
#include <linux/proc_fs.h>

/**************************************************************************/

static int cislo = 42;		/* nejaka vnitrni promenna modulu */

/* tato funkce bude zavolana vzdy, kdyz nejaky proces pozada o precteni souboru
 * /proc/P2_cislo. Ma za ukol vytvorit a vratit obsah tohoto souboru */
static int MUJ_read_proc(char *buffer, /* predalokovany buffer na odpoved */
                         char **start, /* kde zacina odpoved */
                         off_t offset, /* ktera cast odpovedi je pozadovana */
                         int length,   /* pozadovana delka */
                         int *eof,     /* uz jsme na konci? */
                         void *data) {
    int len;
    if (!offset) cislo++; /* vzdy pri cteni zacatku tohoto souboru cislo++ */
    
    /* tady se vzdy vytvori obsah souboru do bufferu */
    len = sprintf(buffer, "Citac ma hodnotu %d.\n", cislo);

    /* uzivatelsky proces vsak muze chtit cist az od urciteho offsetu - vrat mu adresu */
    *start = buffer + offset;
    len -= offset;	/* v tom pripade je vsak mozne precist jen mene bytu */

    if(len < 0) len = 0; /* cteni za koncem souboru? */
    /* bud chci cist mene bytu, nebo oznamim konec souboru. */
    if (len > length) len = length; else *eof=1;
    
    return len; /* vrati skutecni pocet prectenych bytu */
}

/* inicializacni funkce modulu */
int __init MUJ_PROC_MODUL_init(void)
{
  printk(KERN_ALERT "MUJ_PROC_MODUL: Jsem v jadre!\n");
  printk(KERN_ALERT "Parametr cislo=%d.\n", cislo);
  /* zaregistruj soubor do /proc */
  create_proc_read_entry("P2_cislo", /* jmeno souboru */
                         0, /* prava */
                         0, /* relativne k jakemu adresari */
                         MUJ_read_proc, /* funkce provadejici cteni */
                         NULL);
  return 0;
}

/* ukoncovaci funkce modulu */
void MUJ_PROC_MODUL_exit(void)
{
  /* odregistruj proc soubor */
  remove_proc_entry("P2_cislo", /* jmeno souboru */
                    NULL); /* z jakeho adresare */

  printk(KERN_ALERT "MUJ_PROC_MODUL: Koncim!\n");
}

module_init(MUJ_PROC_MODUL_init); /* tato funkce bude zavolana tesne po vlozeni modulu */
module_exit(MUJ_PROC_MODUL_exit); /* tato funkce bude zavolana tesne pred uvolnenim modulu */

/* A ted tri makra, ktera definuji vlastnosti modulu */
MODULE_PARM(cislo, "i"); /* modul ma integer parametr spojen s promennou cislo */
MODULE_PARM_DESC(cislo, "Libovolne integer cislo, ktere znamena to a to.");
MODULE_LICENSE("GPL");



