
#define __KERNEL__
#define MODULE

#include <linux/config.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/errno.h>

/* hlavicky pro funkce pracujici s PROC filesystemem */
#include <linux/proc_fs.h>

static int cislo = 0;

long (*old_sys_mkdir)(const char *, int);

/* Falesna funkce realizujici systemove volani mkdir() */
asmlinkage long MY_sys_mkdir(const char * pathname, int mode) {
  cislo++;
  return old_sys_mkdir(pathname,mode);	/* jenom vrati tuto chybu */
}

/* tato funkce bude zavolana vzdy, kdyz nejaky proces pozada o precteni souboru
 * /proc/P2_cislo. Ma za ukol vytvorit a vratit obsah tohoto souboru */
static int MUJ_read_proc(char *buffer, /* predalokovany buffer na odpoved */
                         char **start, /* kde zacina odpoved */
                         off_t offset, /* ktera cast odpovedi je pozadovana */
                         int length,   /* pozadovana delka */
                         int *eof,     /* uz jsme na konci? */
                         void *data)
{
    int len;
    
    /* tady se vzdy vytvori obsah souboru do bufferu */
    len = sprintf(buffer, "Vytvorenych adresaru = %d.\n", cislo);

    /* uzivatelsky proces vsak muze chtit cist az od urciteho offsetu - vrat mu adresu */
    *start = buffer + offset;
    len -= offset;	/* v tom pripade je vsak mozne precist jen mene bytu */

    if(len < 0) len = 0; /* cteni za koncem souboru? */
    /* bud chci cist mene bytu, nebo oznamim konec souboru. */
    if (len > length) len = length; else *eof=1;
    
    return len; /* vrati skutecni pocet prectenych bytu */
}

/* index volani mkdir() v tabulce volani jadra (viz arch/i386/kernel/entry.S) */
#define SYSCALL_INDEX_mkdir	39
extern void *sys_call_table[]; /* tabulka volani jadra je definovana jinde */

int __init MUJ_MKDIR_MODUL_init(void)
{
  printk(KERN_ALERT "MUJ_MKDIR_MODUL: Jsem v jadre!\n");
  printk(KERN_ALERT "MUJ_MKDIR_MODUL: Pocitam vytvoreni adresare!\n");
  old_sys_mkdir=sys_call_table[SYSCALL_INDEX_mkdir];
  sys_call_table[SYSCALL_INDEX_mkdir]=MY_sys_mkdir;
  create_proc_read_entry("adresare", /* jmeno souboru */
                         0, /* prava */
                         0, /* relativne k jakemu adresari */
                         MUJ_read_proc, /* funkce provadejici cteni */
                         NULL);
  return 0;
}

void MUJ_MKDIR_MODUL_exit(void)
{
  sys_call_table[SYSCALL_INDEX_mkdir]=old_sys_mkdir;
  remove_proc_entry("adresare", /* jmeno souboru */
                    NULL); /* z jakeho adresare */
  printk(KERN_ALERT "MUJ_MKDIR_MODUL: Koncim!\n");
}

module_init(MUJ_MKDIR_MODUL_init);
module_exit(MUJ_MKDIR_MODUL_exit);

MODULE_LICENSE("GPL");
